/***************************************************************************
PROGRAM:	p2.c  (phase II)
PROGRAMMERS:	John White and Yaoen Zhang
DATE:		November 12, 1991
INSTRUCTOR:	Dr. Shaffer - CS4204
DESCRIPTION:	This program allows primitive 3D design with a "box"
		  in 3-space and multiple texture maps.
CONSTITUENT
MODULES:	p2.c sub1.c back.c, command.c, rotate.c, midmove.c,
		slider.c, turn.c, texture.c, pbiinit.c, pbitdraw.c
		pbitprocs.c
INCLUDE FILE:   p2.h, pbitdraw.h
RESOURCE FILE:  .p2

USAGE:		start.s  (shell script)
SYSTEM:		X Windows, Athena Widget set on a MAC II
BUGS:
 **************************************************************************/

#include "p2.h"
String fallback_resources[] = {          /* fallback resources */
	"*canvas.Width:470",
	"*canvas.Height:400",
	NULL,
}; 
int current_map = 5;			/* flag for current tile */

main(argc, argv)
int argc;
char **argv;
{
    extern void init_canvas_data();	/* initialize box attribute data */
    extern void init_rotate_matrix();	/* initialize matrix: rotate, scale, translate*/
    extern void global_box();  		/* setup the starting box */
    extern void starting_box();	 	/* called by EXPOSURE event of canvas*/
    extern void starting_tile();	/* draw the tile pattern on window*/
    extern void initialize();           /* initialize the tiling matrix */

    extern void command_button();       /* command button widgets */
    extern void slider_button();        /* rotation buttons */
    extern void rotation_button();      /* slider buttons   */
    extern void translation_button();   /* translation buttons */

    int i;
    XtAppContext app_con;
    Widget toplevel, form, canvas, message,slabel,box0,box1,box2,tile_win;
    canvas_data *in_data;       /* holds screen and box information */

    in_data = (canvas_data *) malloc (sizeof(canvas_data));
    global_box();		/* Setup starting box attributes */ 
    init_rotate_matrix(rotation);/* Initialize rotation matrix */
    init_rotate_matrix(back_rotation);/* Initialize inverse rotation matrix */
    initialize();		/* Initialize the tile matrix */

    toplevel = XtAppInitialize(&app_con, "Project", NULL, ZERO,
			 &argc, argv, fallback_resources, NULL, ZERO);

    /*  Form widget: holds command buttons and canvas */
    form = XtCreateManagedWidget("form", formWidgetClass, toplevel, NULL, ZERO);
    XtAddEventHandler(form,ExposureMask,FALSE,starting_box,in_data);

    /* create a canvas for rendering */  
    canvas = XtCreateManagedWidget("canvas", boxWidgetClass, form, NULL, ZERO);
    /* Message window under the canvas */
    message = XtCreateManagedWidget("message", labelWidgetClass, form,NULL,ZERO);
    /* Command buttons: quit, edit, texture*/
    command_button(form,in_data);

    /* Three rotation buttons: X axis, Y axis, and Z axis */ 
    rotation_button(form,in_data);

    /* Scale sliders: label, xslider, yslider, zslider */
    slabel=XtCreateManagedWidget("slabel",labelWidgetClass,form,NULL,ZERO);
    box0 = XtCreateManagedWidget("box0", boxWidgetClass,form, NULL, ZERO);
    box1 = XtCreateManagedWidget("box1", boxWidgetClass,form, NULL, ZERO);
    box2 = XtCreateManagedWidget("box2", boxWidgetClass,form, NULL, ZERO);
    slider_button(box0,box1,box2, in_data);

    /* translation buttons: zoom in, zoom out, up, down, left, and right */
    translation_button(form, in_data);
    /*add a tiling window */
    tile_win=XtCreateManagedWidget("tile_win",boxWidgetClass,form,NULL,ZERO);
    XtAddEventHandler(tile_win,ExposureMask,FALSE,starting_tile,in_data);
    
    XtRealizeWidget(toplevel); 

    /* initialize parms with values of the various widgets */
    init_canvas_data(canvas,message,slabel,tile_win,box0,box1,box2,in_data);
    /* keeps the window intact after the popup window */
    {
      XSetWindowAttributes sw;
      sw.backing_store = Always;
      XChangeWindowAttributes(XtDisplay(canvas),XtWindow(canvas),
                                (unsigned long)CWBackingStore,&sw);
    }

    XtAppMainLoop(app_con);
}


